-- GameTimesWindow.lua
-- written by Habna


function frmGameTimeWindow()
	frmGT = true;

	wGameTime = Turbine.UI.Lotro.Window()
	--wGameTime = Turbine.UI.Lotro.GoldWindow()
	
	-- **v Set backcolor, position, size and text of the window v**
	wGameTime:SetText( L["GTWTitle"] );
	wGameTime:SetWantsKeyEvents( true );
	wGameTime:SetVisible( true );
	--wGameTime:SetZOrder( 2 );
	wGameTime:Activate();

	wGameTime.KeyDown = function( sender, args )
		if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
			wGameTime:Close();
		elseif ( args.Action == 268435635 ) or ( args.Action == 268435579 ) then -- Hide if F12 key is press or reposition UI
			wGameTime:SetVisible( not wGameTime:IsVisible() );
		end
	end

	wGameTime.MouseUp = function( sender, args )
		settings.GameTime.L = string.format("%.0f", wGameTime:GetLeft());
		settings.GameTime.T = string.format("%.0f", wGameTime:GetTop());
		GTWLeft, GTWTop = wGameTime:GetPosition();
		SaveSettings( false );
	end

	wGameTime.Closing = function( sender, args ) -- Function for the Upper right X icon
		wGameTime = nil;
		frmGT = nil;
	end
	-- **^
	-- **v Check box - label v**
	local Clock24Ctr = Turbine.UI.Lotro.CheckBox();
	Clock24Ctr:SetParent( wGameTime );
	Clock24Ctr:SetPosition( 40, 40 );
	Clock24Ctr:SetText( L["GTW24h"] );
	Clock24Ctr:SetSize( string.len(Clock24Ctr:GetText()) * 8, 30 );
	--Clock24Ctr:SetVisible( true );
	--Clock24Ctr:SetEnabled( false );
	Clock24Ctr:SetChecked( Clock24h );
	Clock24Ctr:SetForeColor( Color["rustedgold"] );

	Clock24Ctr.CheckedChanged = function( sender, args )
		_G.Clock24h = Clock24Ctr:IsChecked();
		settings.GameTime.H = _G.Clock24h;
		SaveSettings( false );
		UpdateGameTime();
		--ReplaceModuleLocation( "right" );
	end
	-- **^

	wGameTime:SetSize( Clock24Ctr:GetWidth() + 80, 50 );
	wGameTime:SetPosition( GTWLeft, GTWTop );
end