-- en.lua
-- Written by Habna


_G.L = {};
L["TBLang"] = "TitanBar: English language loaded!";
L["TBLoad"] = "TitanBar " .. Version .. " by Habna loaded!";

-- TitanBar Menu
L["MBag"] = "Wallet ...";
L["MGSC"] = "Money";
L["MDP"] = "Destiny points";
L["MSP"] = "Shard";
L["MSM"] = "Mark";
L["MMP"] = "Medallion";
L["MSL"] = "Seal";
L["MCP"] = "Commendation";
L["MBI"] = "Backpack infos";
L["MPI"] = "Players infos";
L["MEI"] = "Equipment infos";
L["MDI"] = "Durability infos";
L["MPL"] = "Player Location";
L["MGT"] = "Time";
L["MPP"] = "Profile";
L["MSC"] = "Shell commands";
L["MRA"] = "Reset all settings";
L["MUTB"] = "Unload";
L["MRTB"] = "Reload";
L["MATB"] = "About ";
L["MBG"] = "Set back color";
L["MCL"] = "Change language to ...";
L["MCLen"] = "English";
L["MCLfr"] = "French";
L["MCLde"] = "Deutsch";

-- Control Menu
L["MCU"] = "Unload ...";
L["MCBG"] = "Change back color of this control";
L["MTBBG"] = "Apply TitanBar back color to ...";
L["MTBBGC"] = "this control";
L["MTBBGAC"] = "all control";
L["MCRBG"] = "Reset back color of ...";
L["MCABT"] = "Apply this control back color to ...";
L["MCABTA"] = "all control & TitanBar";
L["MCABTTB"] = "TitanBar";
L["MCRC"] = "Refresh ...";

-- Background window
L["BWTitle"] = "Set back color";
L["BWAlpha"] = "Alpha";
L["BWCurSetColor"] = "Currently set color";
L["BWApply"] = " Apply currently selected color to all control";
L["BWSave"] = "Save color";
L["BWDef"] = "Default";
L["BWBlack"] = "Black";
L["BWTrans"] = "Transparent";

-- Money infos window
L["MIWTitle"] = "Wallet";
L["MIWTotal"] = "Total";
L["MIWAll"] = "Display total on TitanBar";
L["MIWCM"] = "Display player money";
L["MIWID"] = " wallet info deleted!"

-- GameTime window
L["GTWTitle"] = "Game Time";
L["GTW24h"] = "Display time in 24 hour format";

-- Profile window
L["PWLoad"] = "Load"; 
L["PWSave"] = "Save";
L["PWCreate"] = "Create";
L["PWCancel"] = "Cancel";
L["PWNFound"] = "No profile was found";
L["PWEPN"] = "Enter a profile name";
L["PWProfil"] = "Profile";
L["PWDeleted"] = "deleted";
L["PWLoaded"] = "loaded";

-- Shell commands window
L["SCWTitle"] = "TitanBar Shell Commands";
L["SCWC1"] = "Show TitanBar Options";
L["SCWC2"] = "Unload TitanBar";
L["SCWC3"] = "Reload TitanBar";
L["SCWC4"] = "Reset all settings to default";
L["SCWC5"] = "Show/hide Wallet control";
L["SCWC6"] = "Show/hide Destiny Points control";
L["SCWC7"] = "Show/hide Backpack control";
L["SCWC8"] = "Show/hide Player control";
L["SCWC9"] = "Show/hide Equipment control";
L["SCWC10"] = "Show/hide Durability control";
L["SCWC11"] = "Show/hide Player location control";
L["SCWC12"] = "Show/hide Time control";
L["SCWC13"] = "Show/hide Shell Commands window";
L["SCWC14"] = "Show/hide shard control";
L["SCWC15"] = "Show/hide skirmish marks control";
L["SCWC16"] = "Show/hide medallion control";
L["SCWC17"] = "Show/hide seal control";
L["SCWC18"] = "Show/hide Commendation control";
--L["SCWC??"] = "Show About TitanBar window";

-- Shell commands
L["SC0"] = "Command not supported";
L["SC1"] = "opt / options";
L["SC2"] = "  u / unload";
L["SC3"] = "  r / reload";
L["SC4"] = " ra / resetall";
L["SC5"] = " mi / money";
L["SC6"] = " dp / destiny";
L["SC7"] = " bi / bag";
L["SC8"] = " pi / player";
L["SC9"] = " ei / equipment";
L["SC10"] = " di / durability";
L["SC11"] = " pl / location";
L["SC12"] = " gt / time";
L["SC13"] = " sc / shell";
L["SC14"] = " sp / shards";
L["SC15"] = " sm / skirmish marks";
L["SC16"] = " mp / medallions";
L["SC17"] = " sl / seals";
L["SC18"] = " cp / Commendations";
--L["SCWC??"] = "ab / about";

-- Durability infos window
L["DWTitle"] = "Durability infos";
L["DWLbl"] = "Items currently on your character     Durability";

-- Equipment infos window
L["EWTitle"] = "Equipment infos";
L["EWLbl"] = "Items currently on your character      Score";
L["EWQuality"] = "Quality";
L["EWDurability"] = "Durability";
L["EWItemNP"] = " Item not present";
L["EWItemF"] = " item was found";
L["EWItemsF"] = " items was found";
L["EWQM1"] = "All Quality";
L["EWQM2"] = "Common";
L["EWQM3"] = "UnCommon";
L["EWQM4"] = "Incomparable";
L["EWQM5"] = "Rare";
L["EWQM6"] = "Legendary";
L["EWDM1"] = "All Durability";
L["EWDM2"] = "Weak";
L["EWDM3"] = "Substantial";
L["EWDM4"] = "Brittle";
L["EWDM5"] = "Normal";
L["EWDM6"] = "Tough";
L["EWDM7"] = "Filmsy";
L["EWDM8"] = "Indestructible";
L["EWST1"] = "Head";
L["EWST2"] = "Left Earring";
L["EWST3"] = "Right Earring";
L["EWST4"] = "Necklace";
L["EWST5"] = "Shoulder";
L["EWST6"] = "Back";
L["EWST7"] = "Chest";
L["EWST8"] = "Left Bracelet";
L["EWST9"] = "Right Bracelet";
L["EWST10"] = "Left Ring";
L["EWST11"] = "Right Ring";
L["EWST12"] = "Gloves";
L["EWST13"] = "Legs";
L["EWST14"] = "Feet";
L["EWST15"] = "Pocket";
L["EWST16"] = "Primary Weapon";
L["EWST17"] = "Secondary Weapon/Shield";
L["EWST18"] = "Ranged Weapon";
L["EWST19"] = "Craft Tool";
L["EWST20"] = "Class";

-- Player Infos control
L["PINAME"] = "Your name";
L["PILVL"] = "Your level";
L["PIICON"] = "Your are a ";

-- Money Infos control
L["MGh"] = "Quantity of gold";
L["MSh"] = "Quantity of silver";
L["MCh"] = "Quantity of copper";

-- Destiny Points control
L["DPh"] = "These are your destiny points";

-- Shards control
L["SPh"] = "These are your shard";

-- Skirmish marks control
L["SMh"] = "These are your skirmish marks";

-- Medallions control
L["MPh"] = "These are your medallion";

-- Seals control
L["SLh"] = "These are your seal";

-- Commendations control
L["CPh"] = "These are your Commendation";

-- Bag Infos control
L["BIh"] = "Backpack informations";
L["BIt1"] = "Number of occupied slots/max";

-- Equipment Infos control
L["EIh"] = "Points for all your equipment";
L["EIt1"] = "Left click to see more infos";
L["EIt2"] = "Hold left click to move the control";
L["EIt3"] = "Right click to get control menu";

-- Durability Infos control
L["DIh"] = "Durability of all your equipment";

-- Player Location control
L["PLh"] = "This is where you are";
L["PLMsg"] = "Enter a City!";

-- Game Time control
L["GTh"] = "Time";

-- Chat message
L["TBR"] = "TitanBar: All my settings was set back to default";

-- Character Race
L["Elf"] = "Elf ";
L["Man"] = "Man ";
L["Dwarf"] = "Dwarf ";
L["Hobbit"] = "Hobbit ";

-- Free People Class
L["Guardian"] = "Guardian";
L["Captain"] = "Captain";
L["Minstrel"] = "Minstrel";
L["Burglar"] = "Burglar";
L["Hunter"] = "Hunter";
L["Champion"] = "Champion";
L["Lore-Master"] = "Lore-Master";
L["Rune-Keeper"] = "Rune-Keeper";
L["Warden"] = "Warden";

-- Monster Play Class
L["Reaver"] = "Reaver";
L["Weaver"] = "Weaver";
L["Blackarrow"] = "Blackarrow";
L["Warleader"] = "Warleader";
L["Stalker"] = "Stalker";
L["Defiler"] = "Defiler";


-- Text
--L[""] = "";