-- Main.lua
-- written by Habna


import "Turbine";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Turbine.Gameplay";

Version = "v1.10.13"; --> ** TitanBar current version **
_G.sFromCtr = nil;
_G.STM = nil;
_G.SCM = nil;
_G.Clock24h = nil;
_G.Debug = false; -- True will enable some functions when i'm debuging

screenWidth, screenHeight = Turbine.UI.Display.GetSize();
--left, top = ( screenWidth / 2 ), ( screenHeight / 2 );
write = Turbine.Shell.WriteLine;

--**v Get player instance v**
if pcall( Turbine.Gameplay.LocalPlayer.GetInstance ) then
	Player = Turbine.Gameplay.LocalPlayer.GetInstance();
else
	Player = Turbine.Gameplay.LocalPlayer;
end
--**
--**v Get player alignment v**
PlayerAlign = Player:GetAlignment(); --1: Free People / 2: Monster Play
--**^

-- 0x41007f7a (Mail)

--PlayerLink = Player:IsLinkDead();
--write("Link is: " .. tostring(PlayerLink));
-- 0x41007ecc (Good server connection)
-- 0x41007eca (Poor server connection)
-- 0x41007ecb (Broken server connection)

AppDir = "HabnaPlugins.TitanBar";
AppDirD = AppDir..".";

AppClassD = AppDirD.."Class.";
AppCtrD = AppDirD.."Control.";
AppLocaleD = AppDirD.."Locale.";
AppRes = "HabnaPlugins/TitanBar/Resources/";

--**v Detect Game Language v**
GLocale = "en";
if(Turbine.Shell.IsCommand("zusatzmodule")==true) then GLocale = "de";
elseif(Turbine.Shell.IsCommand("conseil")==true) then GLocale = "fr"; end
--**^

import (AppDir);
import (AppDirD.."color");
import (AppDirD.."settings");
LoadSettings();
import (AppDirD.."functions");
import (AppDirD.."functionsCtr");
import (AppDirD.."functionsMenu");
import (AppDirD.."functionsMenuControl");
import (AppDirD.."OptionPanel"); -- LUA option panel file (for in-game plugin manager options tab)
import (AppDirD.."menu");
import (AppDirD.."menuControl");
import (AppDirD.."frmMain");
frmMain();

TitanBarCommand = Turbine.ShellCommand()

function TitanBarCommand:Execute( command, arguments )
	if ( arguments == L["SC1"] or arguments == "opt") then
		TitanBarMenu:ShowMenu();
	elseif ( arguments == L["SC2"] or arguments == "u" ) then
		UnloadTitanBar();
	elseif ( arguments == L["SC3"] or arguments == "r" ) then
		ReloadTitanBar();
	elseif ( arguments == L["SC4"] or arguments == "ra" ) then
		ResetSettings();
	elseif ( arguments == L["SC5"] or arguments == "mi") then
		if PlayerAlign == 1 then ShowHideMoney(); else ShowNS = true; end
	elseif ( arguments == L["SC6"] or arguments == "dp") then
		if PlayerAlign == 1 then ShowHideDestinyPoints(); else ShowNS = true; end
	elseif ( arguments == L["SC14"] or arguments == "sp") then
		if PlayerAlign == 1 then ShowHideShards(); else ShowNS = true; end
	elseif ( arguments == L["SC15"] or arguments == "sm") then
		if PlayerAlign == 1 then ShowHideSkirmishMarks(); else ShowNS = true; end
	elseif ( arguments == L["SC16"] or arguments == "mp") then
		if PlayerAlign == 1 then ShowHideMedallions(); else ShowNS = true; end
	elseif ( arguments == L["SC17"] or arguments == "sl") then
		if PlayerAlign == 1 then ShowHideSeals(); else ShowNS = true; end
	elseif ( arguments == L["SC18"] or arguments == "cp") then
		if PlayerAlign == 1 then ShowHideCommendations(); else ShowNS = true; end
	elseif ( arguments == L["SC7"] or arguments == "bi" ) then
		ShowHideBackpackInfos();
	elseif ( arguments == L["SC8"] or arguments == "pi" ) then
		ShowHidePlayerInfos();
	elseif ( arguments == L["SC9"] or arguments == "ei" ) then
		if PlayerAlign == 1 then ShowHideEquipInfos(); else ShowNS = true; end
	elseif ( arguments == L["SC10"] or arguments == "di" ) then
		if PlayerAlign == 1 then  ShowHideDurabilityInfos(); else ShowNS = true; end
	elseif ( arguments == L["SC11"] or arguments == "pl" ) then
		ShowHidePlayerLoc();
	elseif ( arguments == L["SC12"] or arguments == "gt" ) then
		ShowHideGameTime();
	elseif ( arguments == L["SC13"] or arguments == "sc" ) then
		HelpInfo();
	--elseif ( arguments == L["SC19"] or arguments == "ab") then
		--AboutTitanBar();
	else
		ShowNS = true;
	end

	if ShowNS then write( "TitanBar: " .. L["SC0"] ); ShowNS = nil; end -- Command not supported
end

Turbine.Shell.AddCommand('TitanBar', TitanBarCommand)

Turbine.Plugin.Load = function( self, sender, args )
	--write( L["TBLang"] ); --TitanBar Language
	--write( L["TBLoad"] ); --TitanBar version by Habna loaded!
end